unit BitIndikator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, EmpfangPrototyp, StdCtrls, Buttons, Imglist, StrUtils, Hauptfenster,
  IntegerTerm, ExtCtrls, Menus;

type
  TBitIndikatorForm = class(TEmpfangPrototypForm)
    Bevel: TBevel;
    BitIndikMenu: TPopupMenu;
    ConfigBtn: TMenuItem;
    AktivBtn: TMenuItem;
    N1: TMenuItem;
    DestroyBtn: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ConfigBtnClick(Sender: TObject);
    procedure AktivBtnClick(Sender: TObject);
    procedure DestroyBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    WidgetAktiv: boolean;
    BerechnungsObj: TIntTerm;
    Varis: VarArray;
    NachrichtenID: longword;
    BerechnungsTerm: string;
    AnzeigeWert: integer;
    Margin: integer;       // Abstand der Skala zum Rand
    BitNames: TStrings;
    OnBitmap: TBitmap;
    OffBitmap: TBitmap;
  public
    { Public-Deklarationen }
    procedure NeueNachricht(CANrec: PCANrecord; var FreeMsg: boolean); override;
    procedure KonfigLaden(WerteListe: TStrings); override;
    procedure KonfigSichern(WerteListe: TStrings); override;
  end;

var
  BitIndikatorForm: TBitIndikatorForm;

implementation

uses BitIndikatorKonfig;

{$R *.dfm}

procedure TBitIndikatorForm.FormCreate(Sender: TObject);
var
  i: integer;
  MenuHandle: HMENU;
begin
  inherited;
  MenuHandle:=GetSystemMenu(Self.Handle, False);
  DeleteMenu(MenuHandle, 7, MF_BYPOSITION);
  DeleteMenu(MenuHandle, 6, MF_BYPOSITION);
  DeleteMenu(MenuHandle, 4, MF_BYPOSITION);

  BitNames := TStringList.Create;
  BitNames.Append('Bit 0');

  OnBitmap := TBitmap.Create;
  OnBitmap.Transparent := true;
  TMainForm(owner).CheckerImages.GetBitmap(6, OnBitmap);
  OffBitmap := TBitmap.Create;
  OffBitmap.Transparent := true;
  TMainForm(owner).CheckerImages.GetBitmap(7, OffBitmap);

  BerechnungsObj := TIntTerm.Create;

  SetLength(Varis, 8);
  for i := 0 to high(Varis) do
  begin
    Varis[i].Name := format('d%u',[i]);
    Varis[i].Wert := 0;
  end;

  WidgetAktiv := True;
  Margin := 5;
  AnzeigeWert := 0;
  NachrichtenID := 0;
  BerechnungsTerm := '(d0 << 8) + d1';

//  self.ClientWidth := (SkalenRadius + Margin) * 2;
//  self.ClientHeight := (SkalenRadius + Margin) * 2;
end;

procedure TBitIndikatorForm.FormDestroy(Sender: TObject);
begin
  inherited;
  OnBitmap.Free;
  OffBitmap.Free;
  BitNames.Free;
end;

procedure TBitIndikatorForm.FormPaint(Sender: TObject);
var
  i: integer;
  tempWert: integer;
begin
  inherited;

  if Bevel.Height <> (BitNames.Count * (Margin + OnBitmap.Height) + Margin) then
  begin
    Bevel.Height := BitNames.Count * (Margin + OnBitmap.Height) + Margin;
    self.ClientHeight := Bevel.Top + Bevel.Height + Margin;
  end;

  tempWert := AnzeigeWert;
  for i := 0 to BitNames.Count-1 do
  begin
    if (tempWert and 1) = 1 then
      self.Canvas.Draw(Bevel.Left + Margin + 5,
            Bevel.Top + i * (Margin + OnBitmap.Height) + Margin, OnBitmap)
    else
      self.Canvas.Draw(Bevel.Left + Margin + 5,
            Bevel.Top + i * (Margin + OffBitmap.Height) + Margin, OffBitmap);
    self.Canvas.TextOut(Bevel.Left + (2 * Margin) + OnBitmap.Width + 5,
          Bevel.Top + i * (Margin + OnBitmap.Height) + Margin - 1, BitNames.Strings[i]);
    tempWert := tempWert shr 1;
  end;
end;

procedure TBitIndikatorForm.KonfigLaden(WerteListe: TStrings);
var
  i, n: integer;
  name: String;
begin
  self.Caption := ReadListString(WerteListe, 'Name', self.Caption);
  NachrichtenID := ReadListInteger(WerteListe, 'NachrichtenID', NachrichtenID);
  BerechnungsTerm := ReadListString(WerteListe, 'Term', BerechnungsTerm);

  BitNames.Clear;
  for i := 0 to WerteListe.Count-1 do
  begin
    WerteListe.Names[i];
    if AnsiStartsText('Bit', name) then
    begin
      n := StrToInt(copy(name, 4, 4));
      while (n >= BitNames.count) do
        BitNames.Append('');
      BitNames.Strings[n] := WerteListe.Values[name];
      // <*> ValueFromIndex ist in Delphi 6 noch nicht vohanden
      // WerteListe.ValueFromIndex[i];
    end;
  end;

  if BitNames.Count <= 0 then
    BitNames.Append('Bit 0');

  self.Paint;
  FensterMenuItem.Caption :=  self.Caption;
end;

procedure TBitIndikatorForm.KonfigSichern(WerteListe: TStrings);
var
  i: integer;
begin
  WerteListe.Append(format('Name=%s', [self.Caption]));
  WerteListe.Append(format('NachrichtenID=%u', [NachrichtenID]));
  WerteListe.Append(format('Term=%s', [BerechnungsTerm]));
  for i := 0 to BitNames.Count-1 do
    WerteListe.Append(format('Bit%u=%s', [i, BitNames.Strings[i]]));
end;

procedure TBitIndikatorForm.NeueNachricht(CANrec: PCANrecord; var FreeMsg: boolean);
var
  i: integer;
begin
  if (not WidgetAktiv) or (CANrec.ID <> NachrichtenID) then
    exit;

  for i := 0 to high(Varis) do
    Varis[i].Wert := CANrec.Data[i];

  try
    AnzeigeWert := BerechnungsObj.TermLoesen(BerechnungsTerm, @Varis);
    self.Paint;
  except
    WidgetAktiv := false;
    MessageDlg('Im Berechnungs Term ist ein Fehler aufgetretten:'+#13+#10+
          BerechnungsObj.GetFehlerText, mtError, [mbOk], 0);
  end;
end;


procedure TBitIndikatorForm.ConfigBtnClick(Sender: TObject);
var
  i: integer;
  Form: TBitKonfigForm;
begin
  inherited;
  Form := TBitKonfigForm.Create(self);

  Form.NameEdit.Text := self.Caption;
  Form.CANIDEdit.Text := TMainForm(Owner).GetIDString(NachrichtenID);
  Form.BerechnungsTermEdit.Text := BerechnungsTerm;
  Form.BitNameGrid.RowCount := BitNames.Count + 1;
  Form.BitNameGrid.Cols[1].Text := 'Bit Bezeichnung'+#13+BitNames.Text;

  if Form.ShowModal = mrOK then
  begin
    self.Caption := Form.NameEdit.Text;
    NachrichtenID := Form.CANIDEdit.Tag;
    BerechnungsTerm := Form.BerechnungsTermEdit.Text;
    BitNames.Clear;
    for i := 1 to Form.BitNameGrid.RowCount-1 do
      BitNames.Append(Form.BitNameGrid.Cells[1, i]);

    self.Paint;
    FensterMenuItem.Caption :=  self.Caption;
  end;
  Form.Free;
end;


procedure TBitIndikatorForm.AktivBtnClick(Sender: TObject);
begin
  inherited;
WidgetAktiv := AktivBtn.Checked;
end;


procedure TBitIndikatorForm.DestroyBtnClick(Sender: TObject);
begin
  inherited;
close;
end;

end.
